
$ScreenHide
$Console
_Source _Console
_Dest _Console

Type BMPHeaderType
    id As String * 2 'Should be "BM"
    size As Long 'Size of the data
    rr1 As Integer '
    rr2 As Integer '
    offset As Long 'Position of start of pixel data
    horz As Long '
    wid As Long 'Image width
    hei As Long 'Image height
    planes As Integer '
    bpp As Integer 'Should read 8 for a 256 colour image
    pakbyte As Long '
    imagebytes As Long 'Width*Height
    xres As Long '
    yres As Long '
    colch As Long '
    ic As Long '
    pal As String * 1024 'Stored as &amp;lt;Blue, Green, Red, 0&amp;gt;
End Type

Type BMXHeaderType
    id As String * 3
    ver As _Unsigned _Byte
    Bits As _Unsigned _Byte
    VeraReg As _Unsigned _Byte
    Width As Integer
    Height As Integer
    PalUsed As _Unsigned _Byte
    PalStart As _Unsigned _Byte
    DataStart As _Unsigned Integer
    Compressed As _Byte
    VERABorder As _Unsigned _Byte
    Reserved As String * 16
End Type

Type VPALTYPE
    GB As _Unsigned _Byte
    R As _Unsigned _Byte
End Type

VERA_DEFAULT:
Data 0,0,255,15,0,8,254,10,76,12,197,0,10,0,231,14,133,13,64,6,119,15,51,3,119,7,246,10,143,0,187,11,0,0,17,1,34,2,51,3,68,4,85,5,102,6,119,7,136,8,153,9,170,10,187,11,204,12,221,13,238
Data 14,255,15,17,2,51,4,68,6,102,8,136,10,153,12,187,15,17,2,34,4,51,6,68,8,85,10,102,12,119,15,0,2,17,4,17,6,34,8,34,10,51,12,51,15,0,2,0,4,0,6,0,8,0,10,0,12,0,15,33,2,67,4,100,6,134,8
Data 168,10,201,12,235,15,17,2,50,4,83,6,116,8,149,10,182,12,215,15,16,2,49,4,81,6,98,8,130,10,163,12,195,15,16,2,48,4,64,6,96,8,128,10,144,12,176,15,33,1,67,3,100,5,134,7,168,9,201,11,251
Data 13,33,1,66,3,99,4,132,6,165,8,198,9,247,11,32,1,65,2,97,4,130,5,162,6,195,8,243,9,32,1,64,2,96,3,128,4,160,5,192,6,240,7,33,1,67,3,101,4,134,6,168,8,202,9,252,11,33,1,66,2,100,3,133
Data 4,166,5,200,6,249,7,32,0,65,1,98,1,131,2,164,2,197,3,246,3,32,0,65,0,97,0,130,0,162,0,195,0,243,0,34,1,68,3,102,4,136,6,170,8,204,9,255,11,34,1,68,2,102,3,136,4,170,5,204,6,255,7,34
Data 0,68,1,102,1,136,2,170,2,204,3,255,3,34,0,68,0,102,0,136,0,170,0,204,0,255,0,18,1,52,3,86,4,104,6,138,8,172,9,207,11,18,1,36,2,70,3,88,4,106,5,140,6,159,7,2,0,20,1,38,1,56,2,74,2,92
Data 3,111,3,2,0,20,0,22,0,40,0,42,0,60,0,63,0,18,1,52,3,70,5,104,7,138,9,156,11,191,13,18,1,36,3,54,4,72,6,90,8,108,9,127,11,2,1,20,2,22,4,40,5,42,6,60,8,63,9,2,1,4,2,6,3,8,4,10,5,12,6
Data 15,7,18,2,52,4,70,6,104,8,138,10,156,12,190,15,17,2,35,4,53,6,71,8,89,10,107,12,125,15,1,2,19,4,21,6,38,8,40,10,58,12,60,15,1,2,3,4,4,6,6,8,8,10,9,12,11,15

Dim Shared Fcount
Dim Shared WriteABin
Dim Shared OUTBIN$
Dim Shared OUTPAL$
Dim Shared Magick$
Dim Shared UsedCols$
Dim Shared wid
Dim Shared hei
Dim Shared Show&, Show2&
ReDim Shared ImageData(0) As _Unsigned _Byte
Dim Shared BMXName$
Dim Shared VERAPAL(0 To 255) As VPALTYPE
ChDir _StartDir$

main:
CFlag = 0
UsedCols$ = ""
DefUse$ = "240"
MSG$ = "Enter # of Palette colors to Use. (17-256)"
X$ = _InputBox$("HOW MANY COLORS", MSG$, DefUse$)
If Not IsNum(X$) Then
    _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
    GoTo main:
End If
C% = Val(X$)
If C% < 17 Or C% > 256 Then
    _MessageBox "INVALID INPUT", "TRY AGAIN", "error"
    GoTo main:
End If
UsedCols$ = X$

If Command$ <> "" Then
    FName$ = Command$(1)
    CFlag = -1
End If

If _CommandCount > 1 Then
    For I = 2 To _CommandCount
        FName$ = FName$ + "|" + Command$(I)
    Next I
End If


main2:
If FName$ = "" Then
    FName$ = _OpenFileDialog$("BMX Convertor - Select Image", "", "*.gif|*.jpg|*.png|*.bmp|*.webp|*.aiff|*.jpeg|*.tiff|*.bin|*.BIN", "Image Files", -1)
    If FName$ = "" Then System
End If

Fcount = 0
BINFLAG = -1

MultiLoop:

DivPos = InStr(FName$, "|")
If DivPos <> 0 Then
    MSG$ = "Also write VERA BIN files ?"
Else
    MSG$ = "Also write VERA BIN file ?"
End If
If BINFLAG Then
    WriteABin = _MessageBox("BIN FILE OUTPUT", MSG$, "yesno", "question", 0)
    If WriteABin = 1 Then WriteABin = -1 Else WriteABin = 0
    BINFLAG = 0
End If

If DivPos <> 0 Then
    Fcount = Fcount + 1
    INIMG$ = Left$(FName$, DivPos - 1)
    FName$ = Right$(FName$, Len(FName$) - DivPos)
    If _FileExists(INIMG$) Then
        Doit INIMG$
        Showit
    End If
    GoTo MultiLoop
End If

Fcount = Fcount + 1
Doit FName$
Showit

If Fcount <> 1 Then
    _MessageBox "CONVERSION COMPLETE", Str$(Fcount) + " files converted to BMX.", "info"
Else
    _MessageBox "CONVERSION COMPLETE", FName$ + " Converted to BMX", "info"
End If
Screen 0
_FreeImage Show&


System

Function VERA2RGB& (Vpal As VPALTYPE)
    grn = Int(Vpal.GB / 16) * 16
    VERA2RGB = _RGB32(Vpal.R * 16, grn, (Vpal.GB - grn) * 16, 255)
End Function


Sub Showit
    Static InShow
    If InShow Then
        Screen 0
        _FreeImage Show&
    End If

    _ScreenShow
    _Dest _Console
    Show& = _NewImage(wid * 2, hei * 2, 32)
    Show2& = _NewImage(wid, hei, 32)
    Screen Show2&
    _ScreenHide
    PixIndx& = 0
    For Y = 0 To (hei - 1)
        For X = 0 To (wid - 1)
            PSet (X, Y), VERA2RGB(VERAPAL(ImageData(PixIndx&)))
            PixIndx& = PixIndx& + 1
        Next X
    Next Y
    _PutImage , Show2&, Show&
    Screen Show&
    _Dest _Console
    _Title BMXName$
    _ScreenShow
    _Dest _Console
    _FreeImage Show2&
End Sub

Sub Doit (ImgFile$)
    Addquotes = InStr(ImgFile$, Chr$(32)) > 0
    If Not _FileExists(ImgFile$) Then
        _MessageBox "NOT FOUND", ImgFile$ + " NOT FOUND!", "error"
        Print
        BadFile = -1
        GoTo SkipIt
    End If

    SStart = Len(ImgFile$)

    For DOT = SStart To 2 Step -1
        c$ = Mid$(ImgFile$, DOT, 1)
        If c$ = "." Then DPos = DOT
        If c$ = "." Then Exit For
    Next DOT

    If DPos > 2 Then
        OUTBMX$ = Left$(ImgFile$, DPos - 1) + ".BMX"
        OUTBIN$ = Left$(ImgFile$, DPos - 1) + ".BIN"
        OUTPAL$ = Left$(ImgFile$, DPos - 1) + ".PAL"
    Else
        OUTBMX$ = ImgFile$ + ".BMX"

    End If

    If Addquotes Then ImgFile$ = "'" + ImgFile$ + "'"
    MagickIt ImgFile$, "IN.BMP"
    CONVERTIT "IN.BMP", OUTBMX$

    Kill "IN.BMP"

    SkipIt:
End Sub


Sub MagickIt (Infile$, Outfile$)
    Dim HEADER As BMPHeaderType

    $If WINDOWS Then
        MAGICK$="magick "
    $Else
        Magick$ = "convert "
    $End If

    CMD$ = Magick$ + Infile$ + " -compress none  -depth 8  -type palette BMP3:CHK.BMP"
    rc = _ShellHide(CMD$)
    Open "CHK.BMP" For Binary As #2
    Get #2, , HEADER
    Close #2
    hei = HEADER.hei
    wid = HEADER.wid
    Print
    Print Infile$
    Print " RESOLUTION IS: "; wid; " x "; hei
    Print
    CMD$ = Magick$ + "CHK.BMP" + " -compress none "
    If hei > 240 Or wid > 320 Then CMD$ = CMD$ + " -resize 320x240 "
    CMD$ = CMD$ + " -flip -depth 8 -colors " + UsedCols$ + " -type palette BMP3:" + Outfile$
    Print "EXECUTING..."
    Print CMD$
    Print
    Shell CMD$
    Kill "CHK.BMP"
End Sub


Sub CONVERTIT (INFILENAME$, OUTFILE$)
    Dim USED_Colors(0 To 255) As _Byte
    Dim BmpHeader As BMPHeaderType
    Dim BmxHeader As BMXHeaderType
    Dim ImageSize As _Unsigned Long
    Dim Pixels As _Unsigned Long
    Dim Pix As _Unsigned _Byte
    BMXName$ = OUTFILE$
    Open INFILENAME$ For Binary As #1
    Open OUTFILE$ For Binary As #2

    Get #1, , BmpHeader

    If BmpHeader.wid > 320 Then
        Close 2
        Close 1
        Print "IMPROPER DIMENSIONS TO CONVERT"
        End
    End If
    pad = BmpHeader.wid Mod 4
    If pad = 3 Then
        pad = 1
    Else
        If pad = 1 Then pad = pad + 2
    End If
    ImageSize = BmpHeader.hei * BmpHeader.wid
    ReDim ImageData(0 To (ImageSize - 1)) As _Unsigned _Byte
    wid = BmpHeader.wid
    hei = BmpHeader.hei


    BmxHeader.id = "BMX"
    BmxHeader.ver = 1
    BmxHeader.Bits = 8
    BmxHeader.VeraReg = 3
    BmxHeader.Width = BmpHeader.wid
    BmxHeader.Height = BmpHeader.hei
    BmxHeader.PalUsed = 0
    BmxHeader.PalStart = 0
    BmxHeader.DataStart = 544
    BmxHeader.Compressed = 0
    BmxHeader.VERABorder = 0
    BmxHeader.Reserved = "0000000000000000"

    Put #2, , BmxHeader
    Print
    Print "Writing: "
    Print OUTFILE$
    Print
    Print " Output Resolution: "; BmxHeader.Width; " x "; BmxHeader.Height

    Print " CONVERTING PALLETTE"

    a$ = BmpHeader.pal ' Pal is stored in a 1024 character string

    I% = 1
    For PI% = 0 To 255
        b% = Asc(Mid$(a$, I%, 1)) \ 16 'blue
        g% = Asc(Mid$(a$, I% + 1, 1)) \ 16 'green
        r% = Asc(Mid$(a$, I% + 2, 1)) \ 16 'red
        ' I% + 3 is set to zero.
        gb% = Int((g% * 16) + b%)
        VERAPAL(PI%).GB = gb%
        VERAPAL(PI%).R = r%
        I% = I% + 4
    Next PI%

    Print " WRITING IMAGE DATA"
    If pad = 0 Then
        Get #1, , ImageData()
    Else
        Get #1, BmpHeader.offset - 1, Pix
        i = 0
        For Y = 1 To BmpHeader.hei
            For x = 1 To BmpHeader.wid
                Get #1, , ImageData(i)
                i = i + 1
            Next x
            For p = 1 To pad: Get #1, , Pix: Next p
        Next Y
    End If
    For i = 0 To 255: USED_Colors(i) = 0: Next
    ColorsUsed = 0

    For i = 0 To ImageSize - 1
        If USED_Colors(ImageData(i)) = 0 Then
            USED_Colors(ImageData(i)) = -1
            ColorsUsed = ColorsUsed + 1
        End If
        If ColorsUsed = 256 Then Exit For
    Next i
    Print " COLORS USED:"; ColorsUsed
    If ColorsUsed > 250 Then GoTo Finished

    FreeToIndx = (256 - ColorsUsed) - 1
    Rem If FreeToIndx > &H1F Then FreeToIndx = &H1F
    SCANCOLOR = FreeToIndx + 1


    For ColIndx = 0 To FreeToIndx
        GotSubstituteColor = 0
        For Pixels = 0 To (ImageSize - 1)
            If ImageData(Pixels) = ColIndx Then
                If Not GotSubstituteColor Then
                    U = SCANCOLOR
                    CHECKCOL:
                    If USED_Colors(U) = 0 Then GoTo gotnextcol
                    If U < 255 Then
                        U = U + 1
                        GoTo CHECKCOL
                    End If
                    gotnextcol:
                    SwapPixel = U
                    USED_Colors(U) = -1
                    USED_Colors(ColIndx) = 0
                    VERAPAL(U) = VERAPAL(ColIndx)
                    GotSubstituteColor = -1
                End If
                ImageData(Pixels) = SwapPixel
            End If
        Next Pixels
    Next ColIndx

    Restore VERA_DEFAULT
    For i = 0 To FreeToIndx
        Read VERAPAL(i).GB
        Read VERAPAL(i).R
    Next i

    Finished:
    Put #2, , VERAPAL()
    Put #2, , ImageData()


    Close #2
    Close #1
    If WriteABin Then
        Print "Writing: "; OUTBIN$
        If _FileExists(OUTBIN$) Then Kill (OUTBIN$)
        Open OUTBIN$ For Binary As #2
        Put #2, , ImageData()
        Close #2
        Print "Writing: "; OUTPAL$
        If _FileExists(OUTPAL$) Then Kill (OUTPAL$)
        Open OUTPAL$ For Binary As #2
        Put #2, , VERAPAL()
        Close #2
    End If



    Print OUTFILE1$; " CONVERSION COMPLETE"

End Sub

Function IsNum% (PassedText As String)
    text$ = PassedText
    special$ = UCase$(Left$(text$, 2))
    Select Case special$
        Case "&H", "&B", "&O"
            'check for symbols on right side of value
            r3$ = Right$(text$, 3)
            Select Case r3$
                Case "~&&", "~%%", "~%&" 'unsigned int64, unsigned byte, unsigned offset
                    text$ = Left$(text$, Len(text$) - 3)
                Case Else
                    r2$ = Right$(text$, 2)
                    Select Case r2$
                        Case "~&", "##", "%&", "%%", "~%", "&&" 'unsigned long, float, offset, byte, unsigned integer, int64
                            text$ = Left$(text$, Len(text$) - 2)
                        Case Else
                            r$ = Right$(text$, 1)
                            Select Case r$
                                Case "&", "#", "%", "!" 'long, double, integer, single
                                    text$ = Left$(text$, Len(text$) - 1)
                            End Select
                    End Select
            End Select
            check$ = "0123456789ABCDEF"
            If special$ = "&O" Then check$ = "01234567"
            If special$ = "&B" Then check$ = "01"
            temp$ = Mid$(UCase$(text$), 2)
            For i = 1 To Len(temp$)
                If InStr(check$, Mid$(temp$, i, 1)) = 0 Then Exit For
            Next
            If i <= Len(temp$) Then IsNum = -1
        Case Else
            If _Trim$(Str$(Val(text$))) = text$ Then IsNum = -1
    End Select
End Function


