
$ScreenHide
$Console
_Source _Console
_Dest _Console


Type BMXHeaderType
    id As String * 3
    ver As _Unsigned _Byte
    Bits As _Unsigned _Byte
    VeraReg As _Unsigned _Byte
    Width As Integer
    Height As Integer
    PalUsed As _Unsigned _Byte
    PalStart As _Unsigned _Byte
    DataStart As _Unsigned Integer
    Compressed As _Byte
    VERABorder As _Unsigned _Byte
    Reserved As String * 16
End Type

Type VPALTYPE
    GB As _Unsigned _Byte
    R As _Unsigned _Byte
End Type


Dim Shared Fcount
Dim Shared wid
Dim Shared hei
Dim Shared Show&, Show2&
ReDim Shared ImageData(0) As _Unsigned _Byte
Dim Shared BMXName$
Dim Shared VERAPAL(0 To 255) As VPALTYPE
ChDir _StartDir$

main:
CFlag = 0

If Command$ <> "" Then
    FName$ = Command$(1)
    CFlag = -1
End If

If _CommandCount > 1 Then
    For I = 2 To _CommandCount
        FName$ = FName$ + "|" + Command$(I)
    Next I
End If


main2:
If FName$ = "" Then
    FName$ = _OpenFileDialog$("Select BMX Image file", "", "*.BMX|*.bmx", "BMX Files", 0)
    If FName$ = "" Then System
End If

Fcount = 0

MultiLoop:

DivPos = InStr(FName$, "|")

If DivPos <> 0 Then
    Fcount = Fcount + 1
    INIMG$ = Left$(FName$, DivPos - 1)
    FName$ = Right$(FName$, Len(FName$) - DivPos)
    Doit INIMG$
    Showit
    _MessageBox "Next BMX File", "OK to Proceed", "info"
    GoTo MultiLoop
End If

Fcount = Fcount + 1
Doit FName$
Showit

_MessageBox "DONE", "OK TO CLOSE", "info"

Screen 0
_FreeImage Show&


System

Function VERA2RGB& (Vpal As VPALTYPE)
    grn = Int(Vpal.GB / 16) * 16
    VERA2RGB = _RGB32(Vpal.R * 16, grn, (Vpal.GB - grn) * 16, 255)
End Function


Sub Showit
    Static InShow
    If InShow Then
        Screen 0
        _FreeImage Show&
    End If

    _ScreenShow
    _Dest _Console
    Show& = _NewImage(wid * 2, hei * 2, 32)
    Show2& = _NewImage(wid, hei, 32)
    Screen Show2&
    _ScreenHide
    PixIndx& = 0
    For Y = 0 To (hei - 1)
        For X = 0 To (wid - 1)
            PSet (X, Y), VERA2RGB(VERAPAL(ImageData(PixIndx&)))
            PixIndx& = PixIndx& + 1
        Next X
    Next Y
    _PutImage , Show2&, Show&
    Screen Show&
    _Dest _Console
    _Title BMXName$
    _ScreenShow
    _Dest _Console
    _FreeImage Show2&
End Sub

Sub Doit (ImgFile$)
    Dim BmxHeader As BMXHeaderType
    If Not _FileExists(ImgFile$) Then
        _MessageBox "NOT FOUND", ImgFile$ + " NOT FOUND!", "error"
        Print
        BadFile = -1
        exit sub
    End If
    BMXName$ = ImgFile$
    Open ImgFile$ For Binary As #1

    Get #1, ,BmxHeader
    IF BMXHeader.id <> "BMX" then
       PRINT "Not a BMX File"
       exit sub
    END IF
    IF BMXHeader.ver <> 1 then
       PRINT "Version: ";BMXHeader.ver;"NOT SUPPORTED"
       EXIT Sub
    END IF
    IF BMXHeader.Bits <> 8 THEN
       PRINT "Bit Depth: ";BMXHeader.bits;" NOT SUPPORTED"
       EXIT SUB
    END IF
    IF BMXHeader.Compressed <> 0 then
       PRINT "Compressed BMX's are NOT SUPPORTED"
       EXIT SUB
    END IF
    wid = BMXHeader.Width
    hei = BMXHeader.Height
    ImageSize& = wid * hei
    REDIM ImageData(0 to (ImageSize&-1)) as _unsigned _byte
    PALSize = BMXHeader.PalUsed * 2
    REDIM VERAPAL(BMXHeader.PalStart TO ((BMXHeader.PalStart + BMXHeader.PalUsed) - 1) as VPALTYPE
    GET #1 ,, VERAPAL()
    GET #1 ,, ImageData()
    CLOSE #1

End Sub






